
; pro eis_hk1_reformatter::unpack_ccsds_header, packet_data_array, apid, scount, plength, stime
;   self->trace, 'eis_hk1_reformatter::unpack_ccsds_header'
;   help, packet_data_array
;   apid    = packet_data_array[*, self.hk1_data.apid]
;   scount  = packet_data_array[*, self.hk1_data.scount]
;   plength = packet_data_array[*, self.hk1_data.plength]
;   stime   = packet_data_array[*, self.hk1_data.sc_time]
; end

pro eis_hk1_reformatter__define

    struct = { eis_hk1_reformatter,	 $
      packet       : bytarr(436),    $
		hk1_data   : { eis_hk1_data, $
		apid       : 0,  $
        scount     : 0,  $
        plength    : 0,  $
        sc_time    : 0L, $

        eis_on_off     : 0B, $ ; 187
        dist_28v_volt  : 0B, $ ; 189
        dist_28v_cur   : 0B, $ ; 190

		eis_a_htr_temp : 0B, $ ; 223
        eis_b_htr_temp : 0B, $ ; 224
        eis_c_htr_temp : 0B, $ ; 225

        eis_a_htr_ed   : 0B, $ ; 282
	    eis_b_htr_ed   : 0B, $ ; 282
        eis_c_htr_ed   : 0B, $ ; 282

        eis_icu1_temp  : 0B, $ ; 383
        eis_icu2_temp  : 0B, $ ; 384
        eis_str1_temp  : 0B, $ ; 385
        eis_str2_temp  : 0B, $ ; 386
		eis_str3_temp  : 0B, $ ; 387
        eis_str4_temp  : 0B, $ ; 388
        eis_str5_temp  : 0B, $ ; 389
        eis_str6_temp  : 0B, $ ; 390
        eis_str7_temp  : 0B, $ ; 391

        eis_date_rate  : 0,  $ ; ?

        spares    : bytarr(34)} , $

		inherits eis_status_reformatter }

end
